=== modified file 'dev.cfg'
--- dev.cfg	2006-12-15 09:20:04 +0000
+++ dev.cfg	2006-12-13 08:53:38 +0000
@@ -32,9 +32,8 @@
 # Enable the debug output at the end on pages.
 # log_debug_info_filter.on = False
 
-#server.environment="development"
-server.environment="production"
-#autoreload.package="loggerhead"
+server.environment="development"
+autoreload.package="loggerhead"
 
 # session_filter.on = True
 
@@ -42,8 +41,13 @@
 # unexpected parameter. False by default
 tg.strict_parameters = True
 
-# turn on timer scheduling
-tg.scheduler = True
+loggerhead.folder='/Users/robey/code/paramiko/paramiko'
+loggerhead.branch_name='paramiko-dev'
+#loggerhead.folder='/Users/robey/code/bzr/bzr.dev'
+#loggerhead.branch_name='bzr.dev'
+loggerhead.external_url="http://localhost:8080"
+
+
 
 # LOGGING
 # Logging configuration generally follows the style of the standard

=== removed file 'loggerhead.conf'
--- loggerhead.conf	2006-12-15 09:20:04 +0000
+++ loggerhead.conf	1970-01-01 00:00:00 +0000
@@ -1,16 +0,0 @@
-
-# where is the bazaar branch located, and what should we call it?
-folder='/Users/robey/code/bzr/bzr.dev'
-branch_name='bzr.dev'
-
-# should we cache revisions?  (HIGHLY recommended)  where?
-# this will be a folder containing a couple of files.  if the folder
-# doesn't already exist, we'll create it.
-cachepath='/Users/robey/code/bzr/bzr.dev/.bzr/loggerhead-cache'
-
-# what url should i use in the atom feed, for external sites?
-external_url="http://localhost:8080"
-
-# where's bzrlib?
-bzrpath='/Users/robey/code/bzr/bzr'
-

=== removed file 'loggerhead/TODO'
--- loggerhead/TODO	2006-12-15 09:20:04 +0000
+++ loggerhead/TODO	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-
-* config file
-
-* maybe put this at the footer of each page:
-    paramiko-dev, 419 revisions, 1133 days old
-    first revision: Tue 2003-11-04 08:34:24 +0000
-    latest revision: Sat 2006-12-02 18:33:34 -0800
-    ...or somewhere.
-    ... does this really matter?
-
-* add back the search bar.
-    -- should notice dotted-revnos and use that to jump.
-	-- also search by date should be simple.
-
-* problem: given a folder, find all revisions where items inside that
-  folder have changed.
-    -- stumper.  maybe ask on bazaar-dev ML?
-
-	
\ No newline at end of file

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/__init__.py	2006-12-13 03:02:49 +0000
@@ -1,6 +1,5 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,25 +17,17 @@
 #
 
 import logging
-import time
-
-from configobj import ConfigObj
 
 import turbogears
 from turbogears import controllers
 from cherrypy import HTTPRedirect, NotFound
 
-from loggerhead import util
-
-my_config = ConfigObj('loggerhead.conf', encoding='utf-8')
-util.set_config(my_config)
-
 from loggerhead.controllers.changelog_ui import ChangeLogUI
 from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.annotate_ui import AnnotateUI
-from loggerhead.history import History
+
 
 log = logging.getLogger("loggerhead.controllers")
 
@@ -50,38 +41,3 @@
     @turbogears.expose()
     def index(self):
         raise HTTPRedirect(turbogears.url('/changes'))
-
-
-# force history to be read:
-util.get_history()
-
-
-
-def rebuild_cache():
-    log.info('Rebuilding revision cache...')
-    last_update = time.time()
-    h = util.get_history()
-    count = 0
-    
-    work = h.get_revision_history()
-    for r in work:
-        h.get_change(r)
-        if h.out_of_date():
-            return
-        count += 1
-        if time.time() - last_update > 60:
-            log.info('Revision cache rebuilding continues: %d/%d' % (count, len(work)))
-            last_update = time.time()
-            h.flush_cache()
-    log.info('Revision cache rebuild completed.')
-
-
-# re-index every hour (for now -- maybe should be even longer?)
-index_freq = 3600
-
-turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=rebuild_cache)
-
-# for use in profiling the very-slow get_change() method:
-#h = util.get_history()
-#h._get_change_profiled(h.last_revid)
-

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/annotate_ui.py	2006-12-13 05:43:00 +0000
@@ -1,6 +1,5 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,11 +21,11 @@
 import os
 import posixpath
 import textwrap
-import time
 
 import turbogears
 from cherrypy import HTTPRedirect, session
 
+from loggerhead.history import History
 from loggerhead import util
 
 
@@ -43,11 +42,9 @@
 
     @turbogears.expose(html='loggerhead.templates.annotate')
     def default(self, *args, **kw):
-        z = time.time()
-        h = util.get_history()
-        
+        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
         if len(args) > 0:
-            revid = h.fix_revid(args[0])
+            revid = args[0]
         else:
             revid = None
         
@@ -62,19 +59,23 @@
             log.error('Exception fetching changes: %r, %s' % (x, x))
             raise HTTPRedirect(turbogears.url('/changes'))
             
+        buttons = [
+            ('top', turbogears.url('/changes')),
+            ('revision', turbogears.url([ '/revision', revid ], path=path)),
+            ('history', turbogears.url([ '/changes', revid ], path=path)),
+        ]
+        
         # no navbar for revisions
-        navigation = util.Container()
+        navigation = util.Container(buttons=buttons)
 
         vals = {
-            'branch_name': util.get_config().get('branch_name'),
+            'branch_name': turbogears.config.get('loggerhead.branch_name'),
             'util': util,
             'revid': revid,
             'path': path,
             'history': h,
             'navigation': navigation,
             'change': h.get_change(revid),
-            'contents': list(h.annotate_file(file_id, revid)),
+            'contents': h.annotate_file(file_id, revid),
         }
-        h.flush_cache()
-        log.info('/annotate: %r secs' % (time.time() - z,))
         return vals

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/atom_ui.py	2006-12-11 19:23:51 +0000
@@ -1,6 +1,5 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,16 +18,15 @@
 
 import turbogears
 
+from loggerhead.history import History
 from loggerhead import util
 
 
 class AtomUI (object):
-    
+
     @turbogears.expose(template='loggerhead.templates.atom', format="xml", content_type="application/atom+xml")
     def default(self, *args):
-        h = util.get_history()
-
-        # really, there is no point giving a revid here...
+        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
         if len(args) > 0:
             revid = args[0]
         else:
@@ -37,13 +35,12 @@
         entries = list(h.get_changelist(list(revlist)[:20]))
 
         vals = {
-            'external_url': util.get_config().get('external_url'),
-            'branch_name': util.get_config().get('branch_name'),
+            'external_url': turbogears.config.get('loggerhead.external_url'),
+            'branch_name': turboears.config.get('loggerhead.branch_name'),
             'changes': entries,
             'util': util,
             'history': h,
             'scan_url': '/changes',
             'updated': entries[0].date.isoformat() + 'Z',
         }
-        h.flush_cache()
         return vals

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/changelog_ui.py	2006-12-13 08:53:38 +0000
@@ -1,6 +1,5 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,6 +25,7 @@
 import turbogears
 from cherrypy import HTTPRedirect, session
 
+from loggerhead.history import History
 from loggerhead import util
 
 log = logging.getLogger("loggerhead.controllers")
@@ -48,58 +48,55 @@
 
 
 class ChangeLogUI (object):
-    
+
     @turbogears.expose(html='loggerhead.templates.changelog')
     def default(self, *args, **kw):
-        z = time.time()
-        h = util.get_history()
-        
+        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
         if len(args) > 0:
-            revid = h.fix_revid(args[0])
+            revid = args[0]
         else:
             revid = None
 
         path = kw.get('path', None)
-        start_revid = h.fix_revid(kw.get('start_revid', None))
-        pagesize = int(util.get_config().get('pagesize', '20'))
+        start_revid = kw.get('start_revid', None)
+        pagesize = int(turbogears.config.get('loggerhead.pagesize', '20'))
         
         try:
             revlist, start_revid = h.get_navigation(start_revid, path)
             if revid is None:
                 revid = start_revid
-            if revid not in revlist:
-                # if the given revid is not in the revlist, use a revlist that
-                # starts at the given revid.
-                revlist, start_revid = h.get_navigation(revid, path)
             entry_list = list(h.get_revids_from(revlist, revid))[:pagesize]
             entries = h.get_changelist(entry_list)
         except Exception, x:
             log.error('Exception fetching changes: %r, %s' % (x, x))
             raise HTTPRedirect(turbogears.url('/changes'))
 
+        buttons = [
+            ('top', turbogears.url('/changes')),
+            ('files', turbogears.url([ '/files', revid ])),
+            ('feed', turbogears.url('/atom')),
+        ]
+
         navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revlist=revlist,
-                                    path=path, scan_url='/changes', feed=True)
-        util.fill_in_navigation(h, navigation)
+                                    path=path, buttons=buttons, scan_url='/changes')
+        next_page_revid = h.get_revlist_offset(revlist, revid, pagesize)
+        prev_page_revid = h.get_revlist_offset(revlist, revid, -pagesize)
         
-        entries = list(entries)
-        # add parent & merge-point branch-nick info, in case it's useful
-        for change in entries:
-            for p in change.parents:
-                p.branch_nick = h.get_change(p.revid).branch_nick
-            for p in change.merge_points:
-                p.branch_nick = h.get_change(p.revid).branch_nick
-
         vals = {
-            'branch_name': util.get_config().get('branch_name'),
-            'changes': list(entries),
+            'branch_name': turbogears.config.get('loggerhead.branch_name'),
+            'changes': entries,
             'util': util,
             'history': h,
             'revid': revid,
             'navigation': navigation,
             'path': path,
+            'next_page_revid': next_page_revid,
+            'prev_page_revid': prev_page_revid,
             'last_revid': h.last_revid,
             'start_revid': start_revid,
         }
-        h.flush_cache()
-        log.info('/changes %r: %r secs' % (revid, time.time() - z))
+        if kw.get('style', None) == 'rss':
+            vals['tg_template'] = 'loggerhead.templates.changelog-rss'
+            vals['tg_format'] = 'xml'
+            vals['tg_content_type'] = 'application/rss+xml'
         return vals

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/inventory_ui.py	2006-12-13 03:02:49 +0000
@@ -1,6 +1,5 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,11 +21,11 @@
 import os
 import posixpath
 import textwrap
-import time
 
 import turbogears
 from cherrypy import HTTPRedirect, session
 
+from loggerhead.history import History
 from loggerhead import util
 
 
@@ -43,11 +42,9 @@
 
     @turbogears.expose(html='loggerhead.templates.inventory')
     def default(self, *args, **kw):
-        z = time.time()
-        h = util.get_history()
-        
+        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
         if len(args) > 0:
-            revid = h.fix_revid(args[0])
+            revid = args[0]
         else:
             revid = None
         
@@ -69,21 +66,20 @@
         else:
             file_id = inv.path2id(path)
             
+        buttons = [
+            ('top', turbogears.url('/changes')),
+            ('revision', turbogears.url([ '/revision', revid ])),
+            ('history', turbogears.url([ '/changes', revid ])),
+        ]
+        
         # no navbar for revisions
-        navigation = util.Container()
-
-        # add parent & merge-point branch-nick info, in case it's useful
-        change = h.get_change(revid)
-        for p in change.parents:
-            p.branch_nick = h.get_change(p.revid).branch_nick
-        for p in change.merge_points:
-            p.branch_nick = h.get_change(p.revid).branch_nick
+        navigation = util.Container(buttons=buttons)
 
         vals = {
-            'branch_name': util.get_config().get('branch_name'),
+            'branch_name': turbogears.config.get('loggerhead.branch_name'),
             'util': util,
             'revid': revid,
-            'change': change,
+            'change': h.get_change(revid),
             'path': path,
             'updir': dirname(path),
             'filelist': h.get_filelist(inv, path),
@@ -91,6 +87,4 @@
             'posixpath': posixpath,
             'navigation': navigation,
         }
-        h.flush_cache()
-        log.info('/inventory %r: %r secs' % (revid, time.time() - z))
         return vals

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/revision_ui.py	2006-12-13 08:53:38 +0000
@@ -1,6 +1,5 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,11 +20,11 @@
 import logging
 import os
 import textwrap
-import time
 
 import turbogears
 from cherrypy import HTTPRedirect, session
 
+from loggerhead.history import History
 from loggerhead import util
 
 log = logging.getLogger("loggerhead.controllers")
@@ -35,16 +34,14 @@
 
     @turbogears.expose(html='loggerhead.templates.revision')
     def default(self, *args, **kw):
-        z = time.time()
-        h = util.get_history()
-        
+        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
         if len(args) > 0:
-            revid = h.fix_revid(args[0])
+            revid = args[0]
         else:
             revid = None
         
         path = kw.get('path', None)
-        start_revid = h.fix_revid(kw.get('start_revid', None))
+        start_revid = kw.get('start_revid', None)
         
         try:
             revlist, start_revid = h.get_navigation(start_revid, path)
@@ -53,29 +50,22 @@
         except Exception, x:
             log.error('Exception fetching changes: %r, %s' % (x, x))
             raise HTTPRedirect(turbogears.url('/changes'))
-        
-        navigation = util.Container(revlist=revlist, revid=revid, start_revid=start_revid, path=path,
-                                    pagesize=1, scan_url='/revision', feed=1)
-        util.fill_in_navigation(h, navigation)
 
-        change = h.get_change(revid, get_diffs=True)
+        buttons = [
+            ('top', turbogears.url('/changes')),
+            ('files', turbogears.url([ '/files', revid ])),
+            ('history', turbogears.url('/changes', start_revid=revid, path=path)),
+        ]
         
-        # add parent & merge-point branch-nick info, in case it's useful
-        for p in change.parents:
-            p.branch_nick = h.get_change(p.revid).branch_nick
-        for p in change.merge_points:
-            p.branch_nick = h.get_change(p.revid).branch_nick
+        navigation = util.Container(buttons=buttons, revlist=revlist, revid=revid, start_revid=start_revid, path=path,
+                                    pagesize=1, scan_url='/revision')
         
         vals = {
-            'branch_name': util.get_config().get('branch_name'),
+            'branch_name': turbogears.config.get('loggerhead.branch_name'),
             'revid': revid,
-            'change': change,
-            'start_revid': start_revid,
-            'path': path,
+            'change': h.get_change(revid, get_diffs=True),
             'util': util,
             'history': h,
             'navigation': navigation,
         }
-        h.flush_cache()
-        log.info('/revision: %r seconds' % (time.time() - z,))
         return vals

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2006-12-15 09:20:04 +0000
+++ loggerhead/history.py	2006-12-13 08:53:38 +0000
@@ -1,6 +1,5 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,90 +18,31 @@
 
 import cgi
 import datetime
-import logging
-import os
 import posixpath
-import re
-import shelve
-import sys
 import textwrap
-import threading
-import time
 from StringIO import StringIO
 
-from loggerhead import util
-extra_path = util.get_config().get('bzrpath', None)
-if extra_path:
-    sys.path.insert(0, extra_path)
-
 import bzrlib
 import bzrlib.annotate
 import bzrlib.branch
 import bzrlib.diff
 import bzrlib.errors
-import bzrlib.progress
 import bzrlib.textfile
 import bzrlib.tsort
-import bzrlib.ui
-
-
-log = logging.getLogger("loggerhead.controllers")
-
-
-# cache lock binds tighter than branch lock
-def with_cache_lock(unbound):
-    def cache_locked(self, *args, **kw):
-        self._cache_lock.acquire()
-        try:
-            return unbound(self, *args, **kw)
-        finally:
-            self._cache_lock.release()
-    cache_locked.__doc__ = unbound.__doc__
-    cache_locked.__name__ = unbound.__name__
-    return cache_locked
-
-
-def with_branch_lock(unbound):
-    def branch_locked(self, *args, **kw):
-        self._lock.acquire()
-        try:
-            return unbound(self, *args, **kw)
-        finally:
-            self._lock.release()
-    branch_locked.__doc__ = unbound.__doc__
-    branch_locked.__name__ = unbound.__name__
-    return branch_locked
-
-
-# bzrlib's UIFactory is not thread-safe
-uihack = threading.local()
-
-class ThreadSafeUIFactory (bzrlib.ui.SilentUIFactory):
-    def nested_progress_bar(self):
-        if getattr(uihack, '_progress_bar_stack', None) is None:
-            uihack._progress_bar_stack = bzrlib.progress.ProgressBarStack(klass=bzrlib.progress.DummyProgress)
-        return uihack._progress_bar_stack.get_nested()
-
-bzrlib.ui.ui_factory = ThreadSafeUIFactory()
+
+from loggerhead import util
+
+
+
 
 
 class History (object):
     
     def __init__(self):
-        self._change_cache = None
-        self._cache_lock = threading.Lock()
-        self._lock = threading.RLock()
-    
-    def __del__(self):
-        if self._change_cache is not None:
-            self._change_cache.close()
-            self._change_cache_diffs.close()
-            self._change_cache = None
-            self._change_cache_diffs = None
+        pass
 
     @classmethod
     def from_branch(cls, branch):
-        z = time.time()
         self = cls()
         self._branch = branch
         self._history = branch.revision_history()
@@ -130,66 +70,17 @@
             for parent in self._revision_graph[revid]:
                 self._where_merged.setdefault(parent, set()).add(revid)
 
-        log.info('built revision graph cache: %r secs' % (time.time() - z,))
         return self
     
     @classmethod
     def from_folder(cls, path):
         b = bzrlib.branch.Branch.open(path)
         return cls.from_branch(b)
-
-    @with_branch_lock
-    def out_of_date(self):
-        if self._branch.revision_history()[-1] != self._last_revid:
-            return True
-        return False
-
-    @with_cache_lock
-    def use_cache(self, path):
-        if not os.path.exists(path):
-            os.mkdir(path)
-        # keep a separate cache for the diffs, because they're very time-consuming to fetch.
-        cachefile = os.path.join(path, 'changes')
-        cachefile_diffs = os.path.join(path, 'changes-diffs')
-        
-        # why can't shelve allow 'cw'?
-        if not os.path.exists(cachefile):
-            self._change_cache = shelve.open(cachefile, 'c', protocol=2)
-        else:
-            self._change_cache = shelve.open(cachefile, 'w', protocol=2)
-        if not os.path.exists(cachefile_diffs):
-            self._change_cache_diffs = shelve.open(cachefile_diffs, 'c', protocol=2)
-        else:
-            self._change_cache_diffs = shelve.open(cachefile_diffs, 'w', protocol=2)
-            
-        # once we process a change (revision), it should be the same forever.
-        log.info('Using change cache %s; %d, %d entries.' % (path, len(self._change_cache), len(self._change_cache_diffs)))
-        self._change_cache_filename = cachefile
-        self._change_cache_diffs_filename = cachefile_diffs
-
-    @with_cache_lock
-    def dont_use_cache(self):
-        # called when a new history object needs to be created.  we can't use
-        # the cache files anymore; they belong to the new history object.
-        if self._change_cache is None:
-            return
-        self._change_cache.close()
-        self._change_cache_diffs.close()
-        self._change_cache = None
-        self._change_cache_diffs = None
-
-    @with_cache_lock
-    def flush_cache(self):
-        if self._change_cache is None:
-            return
-        self._change_cache.sync()
-        self._change_cache_diffs.sync()
     
     last_revid = property(lambda self: self._last_revid, None, None)
     
     count = property(lambda self: self._count, None, None)
-
-    @with_branch_lock
+    
     def get_revision(self, revid):
         return self._branch.repository.get_revision(revid)
     
@@ -233,8 +124,7 @@
             if len(parents) == 0:
                 return
             revid = parents[0]
-
-    @with_branch_lock
+        
     def get_short_revision_history_by_fileid(self, file_id):
         # wow.  is this really the only way we can get this list?  by
         # man-handling the weave store directly? :-0
@@ -245,17 +135,6 @@
         revids = [r for r in self._full_history if r in w_revids]
         return revids
 
-    revno_re = re.compile(r'^[\d\.]+$')
-
-    def fix_revid(self, revid):
-        # if a "revid" is actually a dotted revno, convert it to a revid
-        if revid is None:
-            return revid
-        if self.revno_re.match(revid):
-            revid = self._revno_revid[revid]
-        return revid
-    
-    @with_branch_lock
     def get_navigation(self, revid, path):
         """
         Given an optional revid and optional path, return a (revlist, revid)
@@ -268,7 +147,6 @@
         if revid is None:
             revid = self._last_revid
         if path is not None:
-            # since revid is 'start_revid', possibly should start the path tracing from revid... FIXME
             inv = self._branch.repository.get_revision_inventory(revid)
             revlist = list(self.get_short_revision_history_by_fileid(inv.path2id(path)))
         else:
@@ -277,7 +155,6 @@
             revid = revlist[0]
         return revlist, revid
 
-    @with_branch_lock
     def get_inventory(self, revid):
         return self._branch.repository.get_revision_inventory(revid)
 
@@ -287,6 +164,12 @@
         except:
             return []
     
+    def get_left_child(self, revid):
+        for r in self.get_where_merged(revid):
+            if self._revision_graph[r][0] == revid:
+                return r
+        return None
+
     def get_merge_point_list(self, revid):
         """
         Return the list of revids that have merged this node.
@@ -338,59 +221,7 @@
         for revid in revid_list:
             yield self.get_change(revid)
     
-    @with_branch_lock
     def get_change(self, revid, get_diffs=False):
-        if self._change_cache is None:
-            return self._get_change(revid, get_diffs)
-
-        # if the revid is in unicode, use the utf-8 encoding as the key
-        srevid = revid
-        if isinstance(revid, unicode):
-            srevid = revid.encode('utf-8')
-        return self._get_change_from_cache(revid, srevid, get_diffs)
-
-    @with_cache_lock
-    def _get_change_from_cache(self, revid, srevid, get_diffs):
-        if get_diffs:
-            cache = self._change_cache_diffs
-        else:
-            cache = self._change_cache
-            
-        if srevid in cache:
-            c = cache[srevid]
-        else:
-            if get_diffs and (srevid in self._change_cache):
-                # salvage the non-diff entry for a jump-start
-                c = self._change_cache[srevid]
-                if len(c.parents) == 0:
-                    left_parent = None
-                else:
-                    left_parent = c.parents[0].revid
-                c.changes = self.diff_revisions(revid, left_parent, get_diffs=True)
-                cache[srevid] = c
-            else:
-                #log.debug('Entry cache miss: %r' % (revid,))
-                c = self._get_change(revid, get_diffs=get_diffs)
-                cache[srevid] = c
-            
-        # some data needs to be recalculated each time, because it may
-        # change as new revisions are added.
-        merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
-        c.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
-        
-        return c
-    
-    # alright, let's profile this sucka.
-    def _get_change_profiled(self, revid, get_diffs=False):
-        from loggerhead.lsprof import profile
-        import cPickle
-        ret, stats = profile(self._get_change, revid, get_diffs)
-        stats.sort()
-        stats.freeze()
-        cPickle.dump(stats, open('lsprof.stats', 'w'), 2)
-        return ret
-
-    def _get_change(self, revid, get_diffs=False):
         try:
             rev = self._branch.repository.get_revision(revid)
         except (KeyError, bzrlib.errors.NoSuchRevision):
@@ -400,21 +231,20 @@
                 'revno': '',
                 'date': datetime.datetime.fromtimestamp(0),
                 'author': 'missing',
-                'branch_nick': None,
+                'age': 'unknown',
                 'short_comment': 'missing',
-                'comment': 'missing',
-                'comment_clean': 'missing',
                 'parents': [],
-                'merge_points': [],
-                'changes': [],
             }
-            log.error('ghost entry: %r' % (revid,))
             return util.Container(entry)
             
+        now = datetime.datetime.now()
         commit_time = datetime.datetime.fromtimestamp(rev.timestamp)
         
         parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in rev.parent_ids]
 
+        merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
+        merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
+        
         if len(parents) == 0:
             left_parent = None
         else:
@@ -435,11 +265,13 @@
             'revno': self.get_revno(revid),
             'date': commit_time,
             'author': rev.committer,
-            'branch_nick': rev.properties.get('branch-nick', None),
+            'age': util.timespan(now - commit_time) + ' ago',
             'short_comment': short_message,
             'comment': rev.message,
             'comment_clean': [util.html_clean(s) for s in message],
             'parents': parents,
+            'merge_points': merge_points,
+            'left_child': self.get_left_child(revid),
             'changes': self.diff_revisions(revid, left_parent, get_diffs=get_diffs),
         }
         return util.Container(entry)
@@ -449,40 +281,37 @@
         yield a list of (label, title, revid) for a scan range through the full
         branch history, centered around the given revid.
         
-        example: [ ('<<', 'Previous page', 'rrr'), ('-10', 'Forward 10', 'rrr'),
-                   ('*', None, None), ('+10', 'Back 10', 'rrr'),
-                   ('+30', 'Back 30', 'rrr'), ('>>', 'Next page', 'rrr') ]
-        
-        next/prev page are always using the pagesize.
+        example: [ ('(425)', 'Latest', 'rrrr'), ('+1', 'Forward 1', 'rrrr'), ...
+                   ('-300', 'Back 300', 'rrrr'), ('(1)', 'Oldest', 'first-revid') ]
         """
         count = len(revlist)
         pos = self.get_revid_sequence(revlist, revid)
-
-        if pos > 0:
-            yield (u'\xab', 'Previous page', revlist[max(0, pos - pagesize)])
+        if pos < count - 1:
+            yield ('<', 'Back %d' % (pagesize,),
+                   revlist[min(count - 1, pos + pagesize)])
         else:
-            yield (u'\xab', None, None)
-        
-        offset_sign = -1
-        for offset in util.scan_range(pos, count, pagesize):
-            if (offset > 0) and (offset_sign < 0):
-                offset_sign = 0
-                # show current position
-#                yield ('[%s]' % (self.get_revno(revlist[pos]),), None, None)
-#                yield (u'\u2022', None, None)
-                yield (u'\u00b7', None, None)
+            yield ('<', None, None)
+        yield ('(1)', 'Oldest', revlist[-1])
+        for offset in reversed([-x for x in util.scan_range(pos, count)]):
             if offset < 0:
                 title = 'Back %d' % (-offset,)
             else:
                 title = 'Forward %d' % (offset,)
-            yield ('%+d' % (offset,), title, revlist[pos + offset])
-        
-        if pos < count - 1:
-            yield (u'\xbb', 'Next page', revlist[min(count - 1, pos + pagesize)])
+            yield ('%+d' % (offset,), title, revlist[pos - offset])
+        yield ('(%d)' % (len(revlist),) , 'Latest', revlist[0])
+        if pos > 0:
+            yield ('>', 'Forward %d' % (pagesize,),
+                   revlist[max(0, pos - pagesize)])
         else:
-            yield (u'\xbb', None, None)
-    
-    @with_branch_lock
+            yield ('>', None, None)
+    
+    def get_revlist_offset(self, revlist, revid, offset):
+        count = len(revlist)
+        pos = self.get_revid_sequence(revlist, revid)
+        if offset < 0:
+            return revlist[max(0, pos + offset)]
+        return revlist[min(count - 1, pos + offset)]
+    
     def diff_revisions(self, revid, otherrevid, get_diffs=True):
         """
         Return a nested data structure containing the changes between two
@@ -592,7 +421,6 @@
         
         return util.Container(added=added, renamed=renamed, removed=removed, modified=modified)
 
-    @with_branch_lock
     def get_filelist(self, inv, path):
         """
         return the list of all files (and their attributes) within a given
@@ -614,16 +442,13 @@
             
             # last change:
             revid = entry.revision
-            change = self.get_change(revid)
             
             yield util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
-                                 pathname=pathname, revid=revid, change=change, parity=parity)
+                                 pathname=pathname, revid=revid, revno=self.get_revno(revid), parity=parity)
             parity ^= 1
         pass
 
-    @with_branch_lock
     def annotate_file(self, file_id, revid):
-        z = time.time()
         lineno = 1
         parity = 0
         
@@ -631,29 +456,27 @@
         oldvalues = None
         revision_cache = {}
         
-        # because we cache revision metadata ourselves, it's actually much
-        # faster to call 'annotate_iter' on the weave directly than it is to
-        # ask bzrlib to annotate for us.
-        w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
-        last_line_revid = None
-        for line_revid, text in w.annotate_iter(file_revid):
-            if line_revid == last_line_revid:
-                # remember which lines have a new revno and which don't
+        for revno_str, author, date_str, line_rev_id, text in bzrlib.annotate._annotate_file(self._branch, file_revid, file_id):
+            # remember which lines have a new revno and which don't
+            if revno_str == '':
+                revno, author, line_rev_id, change = oldvalues
                 status = 'same'
             else:
+                revno = self.get_revno(line_rev_id)
+                change = revision_cache.get(line_rev_id, None)
+                if change is None:
+                    change = self.get_change(line_rev_id)
+                    revision_cache[line_rev_id] = change
+                oldvalues = (revno, author, line_rev_id, change)
                 status = 'changed'
                 parity ^= 1
-                last_line_revid = line_revid
-                change = revision_cache.get(line_revid, None)
-                if change is None:
-                    change = self.get_change(line_revid)
-                    revision_cache[line_revid] = change
-                trunc_revno = change.revno
-                if len(trunc_revno) > 10:
-                    trunc_revno = trunc_revno[:9] + '...'
-                
-            yield util.Container(parity=parity, lineno=lineno, status=status,
+                
+            
+            trunc_revno = revno
+            if len(revno) > 10:
+                trunc_revno = revno[:9] + '...'
+                
+            yield util.Container(parity=parity, lineno=lineno, revno=revno, author=author, status=status,
                                  trunc_revno=trunc_revno, change=change, text=util.html_clean(text))
             lineno += 1
-        
-        log.debug('annotate: %r secs' % (time.time() - z,))
+

=== removed file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	2006-12-15 01:14:05 +0000
+++ loggerhead/lsprof.py	1970-01-01 00:00:00 +0000
@@ -1,192 +0,0 @@
-# this is copied from the lsprof distro because somehow
-# it is not installed by distutils
-# I made one modification to profile so that it returns a pair
-# instead of just the Stats object
-
-import sys
-import thread
-import threading
-from _lsprof import Profiler, profiler_entry
-
-__all__ = ['profile', 'Stats']
-
-_g_threadmap = {}
-
-
-def _thread_profile(f, *args, **kwds):
-    # we lose the first profile point for a new thread in order to trampoline
-    # a new Profile object into place
-    global _g_threadmap
-    thr = thread.get_ident()
-    _g_threadmap[thr] = p = Profiler()
-    # this overrides our sys.setprofile hook:
-    p.enable(subcalls=True, builtins=True)
-
-
-def profile(f, *args, **kwds):
-    """XXX docstring"""
-    global _g_threadmap
-    p = Profiler()
-    p.enable(subcalls=True)
-    threading.setprofile(_thread_profile)
-    try:
-        ret = f(*args, **kwds)
-    finally:
-        p.disable()
-        for pp in _g_threadmap.values():
-            pp.disable()
-        threading.setprofile(None)
-    
-    threads = {}
-    for tid, pp in _g_threadmap.items():
-        threads[tid] = Stats(pp.getstats(), {})
-    _g_threadmap = {}
-    return ret, Stats(p.getstats(), threads)
-
-
-class Stats(object):
-    """XXX docstring"""
-
-    def __init__(self, data, threads):
-        self.data = data
-        self.threads = threads
-
-    def sort(self, crit="inlinetime"):
-        """XXX docstring"""
-        if crit not in profiler_entry.__dict__:
-            raise ValueError, "Can't sort by %s" % crit
-        self.data.sort(lambda b, a: cmp(getattr(a, crit),
-                                        getattr(b, crit)))
-        for e in self.data:
-            if e.calls:
-                e.calls.sort(lambda b, a: cmp(getattr(a, crit),
-                                              getattr(b, crit)))
-
-    def pprint(self, top=None, file=None):
-        """XXX docstring"""
-        if file is None:
-            file = sys.stdout
-        d = self.data
-        if top is not None:
-            d = d[:top]
-        cols = "% 12s %12s %11.4f %11.4f   %s\n"
-        hcols = "% 12s %12s %12s %12s %s\n"
-        cols2 = "+%12s %12s %11.4f %11.4f +  %s\n"
-        file.write(hcols % ("CallCount", "Recursive", "Total(ms)",
-                            "Inline(ms)", "module:lineno(function)"))
-        for e in d:
-            file.write(cols % (e.callcount, e.reccallcount, e.totaltime,
-                               e.inlinetime, label(e.code)))
-            if e.calls:
-                for se in e.calls:
-                    file.write(cols % ("+%s" % se.callcount, se.reccallcount,
-                                       se.totaltime, se.inlinetime,
-                                       "+%s" % label(se.code)))
-
-    def freeze(self):
-        """Replace all references to code objects with string
-        descriptions; this makes it possible to pickle the instance."""
-
-        # this code is probably rather ickier than it needs to be!
-        for i in range(len(self.data)):
-            e = self.data[i]
-            if not isinstance(e.code, str):
-                self.data[i] = type(e)((label(e.code),) + e[1:])
-            if e.calls:
-                for j in range(len(e.calls)):
-                    se = e.calls[j]
-                    if not isinstance(se.code, str):
-                        e.calls[j] = type(se)((label(se.code),) + se[1:])
-        for s in self.threads.values():
-            s.freeze()
-
-    def calltree(self, file):
-        """Output profiling data in calltree format (for KCacheGrind)."""
-        _CallTreeFilter(self.data).output(file)
-
-
-class _CallTreeFilter(object):
-
-    def __init__(self, data):
-        self.data = data
-        self.out_file = None
-
-    def output(self, out_file):
-        self.out_file = out_file        
-        print >> out_file, 'events: Ticks'
-        self._print_summary()
-        for entry in self.data:
-            self._entry(entry)
-
-    def _print_summary(self):
-        max_cost = 0
-        for entry in self.data:
-            totaltime = int(entry.totaltime * 1000)
-            max_cost = max(max_cost, totaltime)
-        print >> self.out_file, 'summary: %d' % (max_cost,)
-
-    def _entry(self, entry):
-        out_file = self.out_file
-        code = entry.code
-        inlinetime = int(entry.inlinetime * 1000)
-        #print >> out_file, 'ob=%s' % (code.co_filename,)
-        print >> out_file, 'fi=%s' % (code.co_filename,)
-        print >> out_file, 'fn=%s' % (label(code, True),)
-        print >> out_file, '%d %d' % (code.co_firstlineno, inlinetime)
-        # recursive calls are counted in entry.calls
-        if entry.calls:
-            calls = entry.calls
-        else:
-            calls = []
-        for subentry in calls:
-            self._subentry(code.co_firstlineno, subentry)
-        print >> out_file
-
-    def _subentry(self, lineno, subentry):
-        out_file = self.out_file
-        code = subentry.code
-        totaltime = int(subentry.totaltime * 1000)
-        #print >> out_file, 'cob=%s' % (code.co_filename,)
-        print >> out_file, 'cfn=%s' % (label(code, True),)
-        print >> out_file, 'cfi=%s' % (code.co_filename,)
-        print >> out_file, 'calls=%d %d' % (
-            subentry.callcount, code.co_firstlineno)
-        print >> out_file, '%d %d' % (lineno, totaltime)
-
-
-_fn2mod = {}
-
-def label(code, calltree=False):
-    if isinstance(code, str):
-        return code
-    try:
-        mname = _fn2mod[code.co_filename]
-    except KeyError:
-        for k, v in sys.modules.items():
-            if v is None:
-                continue
-            if getattr(v, '__file__', None) is None:
-                continue
-            if not isinstance(v.__file__, str):
-                continue
-            if v.__file__.startswith(code.co_filename):
-                mname = _fn2mod[code.co_filename] = k
-                break
-        else:
-            mname = _fn2mod[code.co_filename] = '<%s>'%code.co_filename
-    if calltree:
-        return '%s %s:%d' % (code.co_name, mname, code.co_firstlineno)
-    else:
-        return '%s:%d(%s)' % (mname, code.co_firstlineno, code.co_name)
-
-
-if __name__ == '__main__':
-    import os
-    sys.argv = sys.argv[1:]
-    if not sys.argv:
-        print >> sys.stderr, "usage: lsprof.py <script> <arguments...>"
-        sys.exit(2)
-    sys.path.insert(0, os.path.abspath(os.path.dirname(sys.argv[0])))
-    stats = profile(execfile, sys.argv[0], globals(), locals())
-    stats.sort()
-    stats.pprint()

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2006-12-15 08:42:22 +0000
+++ loggerhead/static/css/style.css	2006-12-13 08:53:38 +0000
@@ -17,10 +17,6 @@
 	color: black;
 }
 
-img {
-	border: none;
-}
-
 h1 {
     color: #708a96;
 	font-weight: normal;
@@ -86,7 +82,7 @@
     font-size: smaller;
 }
 
-/* navigation button in the pages (the ones at the top left, and bottom) */
+/* navigation button in the pages (the ones at the top left) */
 .buttons {
 }
 
@@ -104,16 +100,12 @@
     color: blue;
 }
 
-.feed img {
-	vertical-align: text-top;
-}
-
 .rbuttons a {
     font-weight: normal;
     color: #000088;
     font-size: 12pt;
-    padding-right: 7px;
-    padding-left: 10px;
+    padding-right: 10px;
+    padding-left: 7px;
     border-left: 1px dotted #8cacbb;
     text-align: right;
     width: auto;
@@ -136,19 +128,6 @@
 }
 
 
-/* ---- sub-links underneath the headline on some pages ----- */
-
-div.links {
-	padding-top: 0.5em;
-	padding-left: 3em;
-	font-size: 50%;
-}
-
-div.links div {
-	margin-bottom: 3px;
-}
-
-
 /* ----- list of merge points for a revision ----- */
 
 .info-entry {
@@ -244,19 +223,11 @@
 .log-entries .revision-details th.files {
 	padding-top: 1em;
 }
-
 .log-entries .revision-details td.files {
+	font-family: monospace;
 	padding-top: 1em;
 }
 
-.log-entries .revision-details td.files .filename {
-	font-family: monospace;
-}
-
-.log-entries .revision-details td.files a.jump {
-    font-size: smaller;
-}
-
 .log-entries .revision-details th.description {
 	padding-top: 1em;
 }
@@ -317,14 +288,10 @@
 	font-family: monospace;
 }
 
-.revision-info table td.files .filename {
+.revision-info table td.files {
 	font-family: monospace;
 }
 
-.revision-info table td.files a.jump {
-	font-size: smaller;
-}
-	
 .revision-info table tr.divider {
     border-top: 1px solid #8cacbb;
 }
@@ -396,10 +363,6 @@
 
 /* ----- file inventory ----- */
 
-.inventory-path {
-	margin-top: 2em;
-}
-
 table.inventory {
 	border-collapse: collapse;
     width: 80%;
@@ -420,7 +383,6 @@
     padding-bottom: 3px;
 	text-align: left;
 }
-
 table.inventory th.permissions {
 	padding-left: 0.5em;
 }
@@ -440,32 +402,15 @@
 
 .inventory td.revision {
     width: 8em;
-    padding-right: 1.5em;
-}
-
-.inventory td.date {
-	font-family: monospace;
-	font-size: smaller;
-	width: 10em;
-	padding-right: 1.5em;
 }
 
 .inventory td.changes-link {
     width: 6em;
-    font-size: smaller;
-}
-
-span.folder {
-    font-family: monospace;
 }
 
 
 /* ----- file annotation ----- */
 
-.annotate-path {
-	font-family: monospace;
-}
-
 .annotate table {
 	border-collapse: collapse;
     width: 100%;
@@ -519,3 +464,9 @@
 .annotate th.text {
 	padding-left: 1em;
 }
+
+.annotate td.changed {
+	xxborder-top: 1px solid #8cacbb;
+}
+
+

=== removed file 'loggerhead/static/images/feed-icon-16x16.gif'
Binary files loggerhead/static/images/feed-icon-16x16.gif and loggerhead/static/images/feed-icon-16x16.gif differ
=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2006-12-15 08:42:22 +0000
+++ loggerhead/templates/annotate.kid	2006-12-13 05:43:00 +0000
@@ -10,12 +10,7 @@
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : <span class="annotate-path">${path}</span> (revision ${change.revno})
-	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${tg.url([ '/files', revid ])}"> browse files </a> </div>
-	    <div> <b>&#8594;</b> <a href="${tg.url('/revision', start_revid=revid)}"> view revision </a> </div>
-	</div>
-</h1>
+<h1> <span class="branch-name">${branch_name}</span> : ${path} (revision ${change.revno}) </h1>
 
 <!-- !FIXME: this is just copied verbatim from revision.kid -->
 <!--div class="revision-info">
@@ -32,17 +27,13 @@
         <tr py:if="len(change.merge_points) > 0">
             <th class="children"> merged in: </th>
             <td class="children">
-                <span py:for="child in change.merge_points">
-                    ${revlink_path(child.revid, child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', None)} &nbsp;
-                </span>
+                <span py:for="child in change.merge_points"> ${revlink(child.revid, '(' + child.revno + ')')} &nbsp; </span>
             </td>
         </tr>
         <tr py:if="len(change.parents) > 1">
         	<th class="parents"> merged from: </th>
         	<td class="parents">
-        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-           	        ${revlink_path(parent.revid, parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', None)} &nbsp;
-                </span></span>
+        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid"> ${revlink(parent.revid, '(' + parent.revno + ')')} &nbsp; </span></span>
         	</td>
         </tr>
 
@@ -64,8 +55,8 @@
         <tr py:for="line in contents" class="parity${line.parity}">
             <td class="lineno ${line.status}"> ${line.lineno} </td>
             <td class="revno ${line.status}">
-                <a py:if="line.status=='changed'" href="${tg.url('/revision', start_revid=line.change.revid, path=path)}"
-                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${line.trunc_revno}</a>
+                <a py:if="line.status=='changed'" href="${tg.url([ '/revision', line.change.revid ], path=path)}"
+                    title="${line.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${line.change.age})">${line.trunc_revno}</a>
             </td>
             <!--td class="author"> ${util.hide_email(line.author)} </td-->
             <td class="text ${line.status}"> ${XML(line.text)} </td>
@@ -73,5 +64,6 @@
     </table>
 </div>
 
+
 </body>
 </html>

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2006-12-15 08:42:22 +0000
+++ loggerhead/templates/changelog.kid	2006-12-13 08:53:38 +0000
@@ -9,11 +9,7 @@
     <span py:def="loglink(revid, text)">
         <a title="Show history" href="${tg.url('/changes', start_revid=revid)}" class="revlink"> ${text} </a>
     </span>
-
-    <span py:def="file_link(filename, revid)">
-        <a href="${tg.url([ '/annotate', revid ], path=filename)}" title="Annotate ${filename}">${filename}</a>
-    </span>
-
+    
     <!-- this is totally matty's fault.  i don't like javacsript. ;) -->
     <script type="text/javascript"> // <!--
     function displayDetails(name, hide, show) {
@@ -63,17 +59,17 @@
         <div class="revision-header">
             <table>
                 <tr>
-                    <td class="revision-number"> ${revlink_path(entry.revid, start_revid, entry.revno, path)} </td>
+                    <td class="revision-number"> ${revlink_path(revid, start_revid, entry.revno, path)} </td>
                     <td class="expand-button">
                         <a href="javascript:displayDetails('${entry.revno}', 'none', '')" id="hide-${entry.revno}" class="show-button">
-                            <img src="${tg.url('/static/images/nav-small-down.gif')}" width="10" height="10" />
+                            <img src="${tg.url('/static/images/nav-small-down.gif')}" width="10" height="10" border="0" />
                         </a>
                         <a href="javascript:displayDetails('${entry.revno}', '', 'none')" id="show-${entry.revno}" class="hide-button">
-                        	<img src="${tg.url('/static/images/nav-small-right.gif')}" witdh="10" height="10" />
+                        	<img src="${tg.url('/static/images/nav-small-right.gif')}" witdh="10" height="10" border="0" />
                         </a>
                     </td>
 					<td class="summary"> ${revlink_path(entry.revid, start_revid, entry.short_comment, path)} </td>
-					<td class="inventory-link"> <a href="${tg.url([ '/files', entry.revid ])}">&#8594; files</a> </td>
+					<td class="inventory-link"> <a href="${tg.url([ '/files', entry.revid ])}">(files)</a> </td>
 				</tr>
 			</table>
         </div>
@@ -87,7 +83,7 @@
 			        </tr>
 			        <tr>
 			            <th class="date">date:</th>
-			            <td class="date"> ${entry.date.strftime('%d %b %Y %H:%M')} &nbsp; (${util.ago(entry.date)}) </td>
+			            <td class="date"> ${entry.date.strftime('%d %b %Y %H:%M')} &nbsp; (${entry.age}) </td>
 			        </tr>
 			    </table>
 			</div>
@@ -96,41 +92,31 @@
 			        <tr py:if="len(entry.merge_points) > 0">
 			            <th class="children"> merged in: </th>
 			            <td class="children">
-			                <span py:for="child in entry.merge_points">
-			                    ${loglink(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} &nbsp; 
-			                </span>
+			                <span py:for="child in entry.merge_points"> ${loglink(child.revid, '(' + child.revno + ')')} &nbsp; </span>
 			            </td>
 			        </tr>
 			        <tr py:if="len(entry.parents) > 1">
 			        	<th class="parents"> merged from: </th>
 			        	<td class="parents">
-			        	    <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid">
-			        	        ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} &nbsp;
-			        	    </span></span>
+			        	    <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid"> ${loglink(parent.revid, '(' + parent.revno + ')')} &nbsp; </span></span>
 			        	</td>
 			        </tr>
 
 			        <tr py:if="entry.changes.added">
 			            <th class="files"> files added: </th>
-			            <td class="files"> <span py:for="filename in entry.changes.added" class="filename">${file_link(filename, entry.revid)} <br /></span> </td>
+			            <td class="files"> <span py:for="filename in entry.changes.added">${filename} <br /></span> </td>
 			        </tr>
 			        <tr py:if="entry.changes.removed">
 			            <th class="files"> files removed: </th>
-			            <td class="files"> <span py:for="filename in entry.changes.removed" class="filename">${file_link(filename, entry.revid)} <br /></span> </td>
+			            <td class="files"> <span py:for="filename in entry.changes.removed">${filename} <br /></span> </td>
 			        </tr>
 			        <tr py:if="entry.changes.renamed">
 			            <th class="files"> files renamed: </th>
-			            <td class="files"> <span py:for="old_filename, new_filename in entry.changes.renamed" class="filename">
-			                ${file_link(old_filename, entry.revid)} => ${file_link(new_filename, entry.revid)}<br />
-			            </span> </td>
+			            <td class="files"> <span py:for="old_filename, new_filename in entry.changes.renamed">${old_filename} => ${new_filename}<br /></span> </td>
 			        </tr>
 			        <tr py:if="entry.changes.modified">
 			            <th class="files"> files modified: </th>
-			            <td class="files"> <span py:for="item in entry.changes.modified">
-			                <span class="filename">${file_link(item.filename, entry.revid)}</span> &nbsp;
-			                <a href="${tg.url([ '/revision', entry.revid ], start_revid=start_revid, path=path) + '#' + item.filename}" class="jump">(jump to diff)</a>
-			                <br />
-			            </span> </td>
+			            <td class="files"> <span py:for="item in entry.changes.modified">${item.filename} <br /></span> </td>
 			        </tr>
 			        <tr>
 			            <th class="description">description:</th>
@@ -146,10 +132,10 @@
     <table>
         <tr>
         	<td class="buttons">
-            	<a py:if="navigation.prev_page_revid" href="${navigation.prev_page_url}"> &lt;&lt; page </a>
+            	<a py:if="prev_page_revid != revid" href="${tg.url([ '/changes', prev_page_revid ], path=path)}"> &lt;&lt; page </a>
 	 		</td>
  			<td class="rbuttons" align="right">
-            	<a py:if="navigation.next_page_revid" href="${navigation.next_page_url}"> page &gt;&gt; </a>
+            	<a py:if="next_page_revid != revid" href="${tg.url([ '/changes', next_page_revid ], path=path)}"> page &gt;&gt; </a>
  			</td>
  		</tr>
  	</table>

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2006-12-15 08:42:22 +0000
+++ loggerhead/templates/inventory.kid	2006-12-13 03:02:49 +0000
@@ -10,12 +10,7 @@
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : files for revision ${change.revno}
-	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${tg.url('/revision', start_revid=revid)}"> view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${tg.url('/changes', start_revid=revid)}"> view branch changes </a> </div>
-	</div>
-</h1>
+<h1> <span class="branch-name">${branch_name}</span> : files for revision ${change.revno} </h1>
 
 <!-- !FIXME: this is just copied verbatim from revision.kid -->
 <div class="revision-info">
@@ -32,17 +27,13 @@
         <tr py:if="len(change.merge_points) > 0">
             <th class="children"> merged in: </th>
             <td class="children">
-                <span py:for="child in change.merge_points">
-                    ${revlink_path(child.revid, child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', None)} &nbsp; 
-                </span>
+                <span py:for="child in change.merge_points"> ${revlink(child.revid, '(' + child.revno + ')')} &nbsp; </span>
             </td>
         </tr>
         <tr py:if="len(change.parents) > 1">
         	<th class="parents"> merged from: </th>
         	<td class="parents">
-        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-        	        ${revlink_path(parent.revid, parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', None)} &nbsp;
-        	    </span></span>
+        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid"> ${revlink(parent.revid, '(' + parent.revno + ')')} &nbsp; </span></span>
         	</td>
         </tr>
 
@@ -53,23 +44,20 @@
     </table>
 </div>
 
-<div class="inventory-path">
-    <b>folder:</b> <span class="folder"> ${path} </span>
-</div>
+folder: <span class="folder"> ${path} </span>
 
 <table class="inventory" width="100%">
     <tr class="header">
         <th class="permissions"> Permissions </th>
         <th> Filename </th>
         <th> Last change </th>
-        <th> When </th>
         <th> History </th>
     </tr>
     
     <tr class="parity1" py:if="updir">
         <td class="permissions">drwxr-xr-x</td>
         <td class="filename directory"><a href="${tg.url([ '/files', revid ], path=updir)}"> (up) </a></td>
-        <td> </td> <td> </td> <td> </td>
+        <td> </td> <td> </td>
     </tr>
 
     <tr py:for="file in filelist" class="parity${file.parity}">
@@ -79,10 +67,10 @@
             <span py:if="file.kind=='symlink'">${file.filename}@</span>
             <a py:if="file.kind=='file'" href="${tg.url([ '/annotate', revid ], path=posixpath.join(path, file.pathname))}">${file.filename}</a>
         </td>
-        <td class="revision"> ${revlink_path(file.revid, file.revid, util.trunc(file.change.revno, 15), posixpath.join(path, file.pathname))} </td>
-        <td class="date"> ${file.change.date.strftime('%d %b %Y %H:%M')} </td>
-        <td class="changes-link"> <a href="${tg.url('/changes', start_revid=file.revid, path=posixpath.join(path, file.pathname))}"> &#8594; changes </a></td>
+        <td class="revision"> ${revlink(file.revid, file.revno)} </td>
+        <td class="changes-link"> <a href="${tg.url([ '/changes', file.revid ], path=posixpath.join(path, file.pathname))}"> (changes) </a></td>
     </tr>
+    <!-- #entries# -->
 </table>
 
 </body>

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2006-12-15 10:11:30 +0000
+++ loggerhead/templates/master.kid	2006-12-13 08:53:38 +0000
@@ -7,35 +7,41 @@
     <title py:replace="''">Your title goes here</title>
     <meta py:replace="item[:]"/>
     <style type="text/css" media="screen">
-@import "${tg.url('/static/css/style.css')}";
+@import "/static/css/style.css";
     </style>
 
 <!-- !define common navbar -->
 <span py:def="navbar()">
-    <!-- !requires: ${navigation: start_revid, revid, revlist, pagesize, buttons, scan_url}, ${history} -->
+    <!-- !requires: ${navigation: revid, revlist, pagesize, buttons, scan_url}, ${history} -->
     <div class="navbar">
         <div class="bar">
             <table>
                 <tr><td>
                     <span class="buttons">
-                        <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                        <a href="${tg.url('/changes')}"> changes </a>
-                        <a href="${tg.url('/files')}"> files </a>
+                        <span py:for="label, url in navigation.buttons">
+                            <a href="${url}"> ${label} </a>
+                        </span>
                     </span>
                 </td><td align="right" py:if="hasattr(navigation, 'revlist')">
-                    <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
-                        <a href="${tg.url('/atom')}"><img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
-                    </span>
                     <span class="navbuttons">
-                    	<span py:if="navigation.prev_page_revid"> <a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>	</span>
-                    	<span py:if="not navigation.prev_page_revid"> &#171; </span>
-                        	revision ${history.get_revno(revid)} (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
-                    	<span py:if="navigation.next_page_revid"> <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>	</span>
-                    	<span py:if="not navigation.next_page_revid"> &#187; </span>
+                        <span py:for="label, l_title, l_revid in history.scan_range(navigation.revlist, navigation.revid, navigation.pagesize)">
+                            <a py:if="l_revid" href="${tg.url([ navigation.scan_url, l_revid ], path=navigation.path, start_revid=navigation.start_revid)}" title="${l_title}"> ${label} </a>
+                            <span py:if="not l_revid"> ${label} </span>
+                        </span>
                     </span>
                 </td></tr>
             </table>
         </div>
+        <div class="navposition">
+            <table>
+                <tr>
+                    <td> </td>
+                    <td class="navposition" align="right" py:if="hasattr(navigation, 'revlist')">
+                        changes: ${len(navigation.revlist) - history.get_revid_sequence(navigation.revlist, navigation.revid)} / ${len(navigation.revlist)}
+                    </td>
+                </tr>
+            </table>
+        </div>
     </div>
 </span>
 

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2006-12-15 08:42:22 +0000
+++ loggerhead/templates/revision.kid	2006-12-13 08:53:38 +0000
@@ -4,23 +4,14 @@
 <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
     <title> ${branch_name} : revision ${change.revno} </title>
-    
-    <span py:def="file_link(filename)">
-        <a href="${tg.url([ '/annotate', revid ], path=filename)}" title="Annotate ${filename}">${filename}</a>
-    </span>
 </head>
 
 <body>
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : revision ${change.revno}
-	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${tg.url([ '/files', revid ])}">browse files</a> </div>
-	    <div> <b>&#8594;</b> <a href="${tg.url('/changes', start_revid=revid)}">view branch changes</a> </div>
-	</div>
-</h1>
- 
+<h1> <span class="branch-name">${branch_name}</span> : revision ${change.revno} </h1>
+
 <div class="revision-info">
     <table>
         <tr>
@@ -35,17 +26,13 @@
         <tr py:if="len(change.merge_points) > 0">
             <th class="children"> merged in: </th>
             <td class="children">
-                <span py:for="child in change.merge_points">
-                    ${revlink_path(child.revid, child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', None)} &nbsp; 
-                </span>
+                <span py:for="child in change.merge_points"> ${revlink(child.revid, '(' + child.revno + ')')} &nbsp; </span>
             </td>
         </tr>
         <tr py:if="len(change.parents) > 1">
         	<th class="parents"> merged from: </th>
         	<td class="parents">
-        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-        	        ${revlink_path(parent.revid, parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', None)} &nbsp;
-        	    </span></span>
+        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid"> ${revlink(parent.revid, '(' + parent.revno + ')')} &nbsp; </span></span>
         	</td>
         </tr>
 
@@ -58,30 +45,26 @@
         
         <tr py:if="change.changes.added">
             <th class="files"> files added: </th>
-            <td class="files"> <span py:for="filename in change.changes.added" class="filename">${file_link(filename)} <br /></span> </td>
+            <td class="files"> <span py:for="filename in change.changes.added">${filename} <br /></span> </td>
         </tr>
         <tr py:if="change.changes.removed">
             <th class="files"> files removed: </th>
-            <td class="files"> <span py:for="filename in change.changes.removed" class="filename">${file_link(filename)} <br /></span> </td>
+            <td class="files"> <span py:for="filename in change.changes.removed">${filename} <br /></span> </td>
         </tr>
         <tr py:if="change.changes.renamed">
             <th class="files"> files renamed: </th>
-            <td class="files"> <span py:for="old_filename, new_filename in change.changes.renamed" class="filename">${file_link(old_filename)} => ${file_link(new_filename)}<br /></span> </td>
+            <td class="files"> <span py:for="old_filename, new_filename in change.changes.renamed">${old_filename} => ${new_filename}<br /></span> </td>
         </tr>
         <tr py:if="change.changes.modified">
             <th class="files"> files modified: </th>
-            <td class="files">
-                <span py:for="item in change.changes.modified">
-                    <span class="filename">${file_link(item.filename)}</span> &nbsp; <a href="#${item.filename}" class="jump">(jump to diff)</a><br />
-                </span>
-            </td>
+            <td class="files"> <span py:for="item in change.changes.modified">${item.filename} <br /></span> </td>
         </tr>
     </table>
 </div>
 
 <div class="diff" py:if="change.changes.modified">
     <table py:for="item in change.changes.modified" class="diff-block">
-        <tr><th class="filename"> <a href="${tg.url([ '/annotate', change.revid ], path=item.filename)}" name="${item.filename}">${item.filename}</a> </th></tr>
+        <tr><th class="filename"> <a href="${tg.url([ '/annotate', change.revid ], path=item.filename)}">${item.filename}</a> </th></tr>
         <tr><td>
             <table py:for="chunk in item.chunks" class="diff-chunk">
                 <tr> <th class="lineno">old</th> <th class="lineno">new</th> <th></th> </tr>
@@ -95,18 +78,5 @@
     </table>
 </div>
 
-<div class="bar">
-    <table>
-        <tr>
-        	<td class="buttons">
-            	<a py:if="navigation.prev_page_revid" href="${navigation.prev_page_url}"> &lt; revision ${history.get_revno(navigation.prev_page_revid)} </a>
-	 		</td>
- 			<td class="rbuttons" align="right">
-            	<a py:if="navigation.next_page_revid" href="${navigation.next_page_url}"> revision ${history.get_revno(navigation.next_page_revid)} &gt; </a>
- 			</td>
- 		</tr>
- 	</table>
-</div>
-
 </body>
 </html>

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2006-12-15 09:20:04 +0000
+++ loggerhead/util.py	2006-12-13 01:45:10 +0000
@@ -1,6 +1,5 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,16 +17,8 @@
 #
 
 import cgi
-import datetime
-import logging
 import re
 import sha
-import threading
-
-import turbogears
-
-
-log = logging.getLogger("loggerhead.controllers")
 
 
 def timespan(delta):
@@ -60,11 +51,6 @@
     return ', '.join(seg)
 
 
-def ago(timestamp):
-    now = datetime.datetime.now()
-    return timespan(now - timestamp) + ' ago'
-    
-
 class Container (object):
     """
     Convert a dict into an object with attributes.
@@ -96,12 +82,6 @@
     return ''.join([ '&#%d;' % ord(c) for c in text ])
 
 
-def trunc(text, limit=10):
-    if len(text) <= limit:
-        return text
-    return text[:limit] + '...'
-
-
 STANDARD_PATTERN = re.compile(r'^(.*?)\s*<(.*?)>\s*$')
 EMAIL_PATTERN = re.compile(r'[-\w\d\+_!%\.]+@[-\w\d\+_!%\.]+')
 
@@ -125,12 +105,12 @@
     return '%s at %s' % (username, domains[0])
 
     
-def triple_factors(min_value=1):
+def triple_factors():
     factors = (1, 3)
     index = 0
     n = 1
     while True:
-        if n >= min_value:
+        if n >= 10:
             yield n * factors[index]
         index += 1
         if index >= len(factors):
@@ -138,7 +118,7 @@
             n *= 10
 
 
-def scan_range(pos, max, pagesize=1):
+def scan_range(pos, max):
     """
     given a position in a maximum range, return a list of negative and positive
     jump factors for an hgweb-style triple-factor geometric scan.
@@ -150,7 +130,7 @@
     invent it. :)
     """
     out = []
-    for n in triple_factors(pagesize + 1):
+    for n in triple_factors():
         if n > max:
             return out
         if pos + n < max:
@@ -177,69 +157,4 @@
         return '-rwxr-xr-x'
     return '-rw-r--r--'
 
-
-def if_present(format, value):
-    """
-    format a value using a format string, if the value exists and is not None.
-    """
-    if value is None:
-        return ''
-    return format % value
-
-
-def fill_in_navigation(history, navigation):
-    """
-    given a navigation block (used by the template for the page header), fill
-    in useful calculated values.
-    """
-    navigation.position = history.get_revid_sequence(navigation.revlist, navigation.revid)
-    navigation.count = len(navigation.revlist)
-    navigation.page_position = navigation.position // navigation.pagesize + 1
-    navigation.page_count = (len(navigation.revlist) + (navigation.pagesize - 1)) // navigation.pagesize
-    
-    def get_offset(offset):
-        if (navigation.position + offset < 0) or (navigation.position > navigation.count - 1):
-            return None
-        return navigation.revlist[navigation.position + offset]
-    
-    navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
-    navigation.next_page_revid = get_offset(1 * navigation.pagesize)
-    if navigation.prev_page_revid:
-        navigation.prev_page_url = turbogears.url([ navigation.scan_url, navigation.prev_page_revid ], path=navigation.path, start_revid=navigation.start_revid)
-    if navigation.next_page_revid:
-        navigation.next_page_url = turbogears.url([ navigation.scan_url, navigation.next_page_revid ], path=navigation.path, start_revid=navigation.start_revid)
-
-
-# global branch history & cache
-
-_history = None
-_history_lock = threading.Lock()
-
-def get_history():
-    global _history
-    from loggerhead.history import History
-    
-    config = get_config()
-    
-    _history_lock.acquire()
-    try:
-        if (_history is None) or _history.out_of_date():
-            log.debug('Reload branch history...')
-            if _history is not None:
-                _history.dont_use_cache()
-            _history = History.from_folder(config.get('folder'))
-            _history.use_cache(config.get('cachepath'))
-        return _history
-    finally:
-        _history_lock.release()
-
-
-_config = None
-
-def set_config(config):
-    global _config
-    _config = config
-
-def get_config():
-    return _config
-
+        

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2006-12-15 10:05:25 +0000
+++ start-loggerhead.py	2006-12-11 06:44:19 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/env python2.4
+#!/Library/Frameworks/Python.framework/Versions/2.4/Resources/Python.app/Contents/MacOS/Python
 import pkg_resources
 pkg_resources.require("TurboGears")
 
@@ -23,6 +23,9 @@
     turbogears.update_config(configfile="prod.cfg",
         modulename="loggerhead.config")
 
+# robey FIXME
+sys.path.insert(0, '/Users/robey/code/bzr/bzr.dev')
+
 from loggerhead.controllers import Root
 
 turbogears.start_server(Root())

